#!/bin/sh

if ! test -f "Install-fstools.sh"
then
	echo "Install-fstools.sh not found. Run configure before trying to install!"
	exit
fi

. lib/install.lib
. ./Install-fstools.sh

src_root=`cd ..; pwd`

inst_install_do_normal

while getopts "lupcF:L:" Option
do
	case $Option in
		l) inst_install_do_link ;;
		u) uninstall=1 ;;
		p) inst_install_do_pretend ;;
		c) inst_install_do_copy;;
		L) with_fs_ln=$OPTARG ; export link=$OPTARG ;;
		F) export fakeroot=$OPTARG
	esac		
done

. data/install_files.sh

if test -z "$uninstall"
then
	inst_install
	echo "GPMI installed."
	echo "(On some systems you may need to run ldconfig after this step.)"
	echo ""
else
	inst_uninstall
fi

