# This lib detects the proper format string for printf to put "0x1234"
# for (void *)0x1234

. lib/compile.lib

function detect_cast {
	q=`echo '
#include <stdlib.h>
#include <stdio.h>
int main() {
	printf("%d %d", sizeof(void *), sizeof('$1'));
	puts("");
	return 0;
}
	'  | test_compile`

	echo "[detect_print_cast] Trying %x with cast $1, $CFLAGS, $LDFLAGS ->$q" >> $LOG

	q1=`echo "$q" | awk '{print $1}'`
	q2=`echo "$q" | awk '{print $2}'`
	
	if test "$q1" = "$q2"
	then
		echo "$1"
		exit 0
	fi
}

detect_cast "unsigned int"
detect_cast "unsigned long"
detect_cast "unsigned long int"
detect_cast "unsigned long long"

# fallback for platforms with longer pointer than the longest integer
echo "void *"
exit 0


