. lib/compile.lib

function try_php {
	q=`echo '
#include <main/php_embed.h>
int main() {
	puts("OK");
	return 0;
}
	'  | test_compile`

	echo "[scripts] Trying php with $1, $CFLAGS, $LDFLAGS $LDFLAGS_extra ->$q" >> $LOG

	if test "$q" = "OK"
	then
		return 0
	fi

echo '

It seems you have php installed, but not php embed. Please install that if you
want php support to work.
                             ' > /dev/stderr


	return 1
}

version=`php-config --version 2>/dev/null| sed "s/\..*//"`

if test -z "$version"
then
	# We don't have php-config at all!
	exit 1
fi

if test "$version" = "3"
then
	# We do not support PHP3!
	exit 1
fi

# Detect the include and ldflags stuff (long long long lines)
include=`php-config --includes 2>/dev/null | tr "\n" " "`
libflags=`php-config --libs 2>/dev/null | tr "\n" " "`
libflags="$libflags `php-config --ldflags 2>/dev/null | tr "\n" " "`"

# See which version we have, and give that info to the module

if test "$version" = "4"
then
	include="$include -DPHP4"
	libflags="$libflags -lphp4"
else
	include="$include -DPHP5"
	libflags="$libflags -lphp5"
fi

# Final test, see if the embed part is installed
LDFLAGS_extra=$libflags
CFLAGS_extra=$include
try_php "" 2>/dev/null && echo "$include | $libflags"

