/*
    libgpmi - General Package/Module Interface
    Copyright (C) 2005-2007 Patric 'TrueLight' Stout & Tibor 'Igor2' Palinkas
  
    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.
  
    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.
  
    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef GPMI_PATHS_H
#define GPMI_PATHS_H

typedef enum gpmi_paths_e {
	GPMI_PATH_MODULES,
	GPMI_PATH_PACKAGES,
	GPMI_PATH_SCRIPTS,
} gpmi_paths_t;

/* A special path that is replaced with the default path for the given group */
extern const char *GPMI_PATH_DEFAULT;

/* Wrappers to read paths */
char *gpmi_path_get(gpmi_paths_t gpmi_path, int *start);


/* Wrappers to manipulate gpmi wrappers */
int gpmi_path_append(gpmi_paths_t gpmi_path, const char *path);
int gpmi_path_insert(gpmi_paths_t gpmi_path, const char *path);
int gpmi_path_find(gpmi_paths_t gpmi_path, const char *path);
int gpmi_path_delete(gpmi_paths_t gpmi_path, const char *path);


/* Direct string manipulation functions */
void gpmi_path_append_(char **gpmi_path, const char *path);
void gpmi_path_insert_(char **gpmi_path, const char *path);
int  gpmi_path_find_(const char **gpmi_path, const char *path);
int  gpmi_path_delete_(char **gpmi_path, const char *path);

#endif /* GPMI_PATHS_H */
