/*
    libgpmi - General Package/Module Interface - cli module
    Copyright (C) 2006-2007 Tibor 'Igor2' Palinkas & glx
  
    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.
  
    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.
  
    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include <gpmi.h>
#include <gpmi/modules.h>
#include "cli.h"

static const GPMI_Script_Info Cli_Proc_Info = {
	&Cli_Initialize,
	&Cli_Destroy,
	&Cli_GetExtension,
	&Cli_RegisterCommand,
	&Cli_LoadScript,
	&Cli_Rehash,
	&Cli_RunFunction,
	0,
};

void gpmi_mod(RunTick)(gpmi_module *module, int frame_counter)
{
	GPMI_Script_RunTick(module, frame_counter);
}

void gpmi_mod(RunData)(gpmi_module *module, void *data)
{
	GPMI_Script_RunData(module, data);
}

/**
 * Run direct Cli command from the console. For debugging.
*/
int gpmi_mod(Debug)(gpmi_module *module, const char *parameters)
{
//	Cli_ClientData *Cli_MyData = module->mod_data;

	return 0;
}

/**
 * Necessarry routines to init/uninit the module
 */
int gpmi_mod(Initialize)(gpmi_module *module, const char *params)
{
	return GPMI_Script_Load(&Cli_Proc_Info, module, params);
}

void gpmi_mod(Uninitialize)(gpmi_module *module)
{
	GPMI_Script_Destroy(module);
}
