/*
    libgpmi - General Package/Module Interface - GHLI module
    Copyright (C) 2005-2007 Tibor 'Igor2' Palinkas
  
    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.
  
    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.
  
    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "ghli_mod.h"
#include <gpmi/debug.h>
#include <gpmi/modules.h>

static const GPMI_Script_Info GHLI_Proc_Info = {
	&GHLI_Initialize,
	&GHLI_Destroy,
	&GHLI_GetExtension,
	&GHLI_RegisterCommand,
	&GHLI_LoadScript,
	&GHLI_Rehash,
	&GHLI_RunFunction,
	&GHLI_SetPkg,
	0,
};

void gpmi_mod(RunTick)(gpmi_module *module, int frame_counter)
{
	GPMI_Script_RunTick(module, frame_counter);
}

void gpmi_mod(RunData)(gpmi_module *module, void *data)
{
	GPMI_Script_RunData(module, data);
}

/**
 * XXX: Does nothing for ghli (no code injection yet!)
*/
int gpmi_mod(Debug)(gpmi_module *module, const char *parameters)
{
	return 0;
}

/**
 * Necessarry routines to init/uninit the module
 */
int gpmi_mod(Initialize)(gpmi_module *module, const char *params)
{
	return GPMI_Script_Load(&GHLI_Proc_Info, module, params);
}

void gpmi_mod(Uninitialize)(gpmi_module *module)
{
	GPMI_Script_Destroy(module);
}
