/*
    libgpmi - General Package/Module Interface - python module
    Copyright (C) 2005-2007 Patric 'TrueLight' Stout & Tibor 'Igor2' Palinkas
  
    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.
  
    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.
  
    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include "python.h"

#include <stdio.h>
#include <string.h>
#include <gpmi/modules.h>

const GPMI_Script_Info Python_Proc_Info = {
	&Python_Initialize,
	&Python_Destroy,
	&Python_GetExtension,
	&Python_RegisterCommand,
	&Python_LoadScript,
	NULL,
	&Python_CallFunction,
	NULL,
	0,
};

void gpmi_mod(Uninitialize)(gpmi_module *module)
{
	GPMI_Script_Destroy(module);
}

int gpmi_mod(Initialize)(gpmi_module *module, const char *params)
{
	int res;

	res = GPMI_Script_Load(&Python_Proc_Info, module, params);

	if (res != 0)
		gpmi_mod(Uninitialize)(module);

	return res;
}

void gpmi_mod(RunTick)(gpmi_module *module, int frame_counter)
{
	GPMI_Script_RunTick(module, frame_counter);
}

void gpmi_mod(RunData)(gpmi_module *module, void *data)
{
	GPMI_Script_RunData(module, data);
}

int gpmi_mod(Debug)(gpmi_module *module, const char *command)
{

	return 0;
}
