/*
    libgpmi - General Package/Module Interface - stutter module
    Copyright (C) 2005-2007 Mate Nagy
  
    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.
  
    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.
  
    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


#ifndef SCRIPT_MODULE_STUTTER_H
#define SCRIPT_MODULE_STUTTER_H

#include "packages/gpmi_scripts.h"
#include <stutter/stutter.h>

typedef struct Stutter_FuncNames Stutter_FuncNames;
struct Stutter_FuncNames {
	char *name;
	Stutter_FuncNames *next;
};

typedef struct {
	varctx *global;
	char *name;
	Stutter_FuncNames *names;
} Stutter_ClientData;

int  Stutter_Initialize(void **client_data);
void Stutter_Destroy(void **client_data);
void Stutter_RegisterCommand(void *client_data, const char *name);
int  Stutter_LoadScript(void *client_data, const char *filename);
char *Stutter_GetExtension();
int  Stutter_Rehash(void *client_data);
void Stutter_RunFunction(void *client_data, const char *function, int argc, const char **argv);

#endif /* SCRIPT_MODULE_STUTTER_H */
