/*
    libgpmi - General Package/Module Interface - example package
    Copyright (C) 2005-2007 Patric 'TrueLight' Stout & Tibor 'Igor2' Palinkas

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include <gpmi.h>

extern const gpmi_keyword_static_int example_colors_ska[];

int Example_int(int offset);
char *Example_string(int num, char *text);
int Example_do_nothing(int param);
unsigned int Example_uint(unsigned int offset);

gpmi_define_event(Example_nothing)(int developement_year, int parameter);

/* The enum version for C */
typedef enum example_colors_e {
	example_red			=	1,
	example_green		=	2,
	example_blue		=	4,
} example_colors_t;

gpmi_keyword *Example_colors_kw; /* of example_colors_t */

example_colors_t Example_color_rot(example_colors_t color);
multiple example_colors_t Example_color_inv(multiple example_colors_t color);

//#define gpmi_namespace_example	ex

