; test Guile with gpmi

(define gTTL 4)
(define gfreq 0)
(define gyear 0)
(define gparam 0)

(define (RunData data)
  (gpmi_puts_nonl (simple-format #f "main:RunData ~A == 0x1234\n" data)))

(define ev_cycle (lambda (data)
  (let ((TTL (TimerInfo data "TTL"))
        (freq (TimerInfo data "freq"))
        (user_data (TimerInfo data "user_data")))

	(gpmi_puts_nonl (simple-format #f "main:ev_cycle ( ~A == ~A ) ( ~A == ~A ) ( ~A == data1 ) (runs 4 times)\n"
				   gTTL TTL gfreq freq user_data))

    (set! gTTL (1- gTTL))))) 

(define ev_every_second (lambda (data)
  (let ((TTL (TimerInfo data "TTL"))
        (freq (TimerInfo data "freq"))
        (user_data (TimerInfo data "user_data")))

	(gpmi_puts_nonl (simple-format #f "main:ev_every_second ( ~A == ~A ) ( ~A == ~A ) ( ~A == data2 ) (runs 3 times)\n"
				   gTTL TTL gfreq freq user_data))

    (set! gTTL (1- gTTL)))))

(define ev_nothing (lambda (id year param)
  (gpmi_puts_nonl (simple-format #f "main:ev_nothing: year: ( ~A == ~A ) param: ( ~A == ~A )\n" gyear year gparam param))))

(define run_once (lambda (data)
  (gpmi_puts_nonl "main:Running init part.\n")

  ;; check timers

  (set! gTTL 4)
  (set! gfreq 0)
  (AddTimer 4 0 "ev_cycle" "data1")
  (set! gTTL 3)
  (set! gfreq 2)
  (AddTimer 3 2 "ev_every_second" "data2")

  ;; check package loading

  (PkgLoad "example" 0)

  (gpmi_puts_nonl (simple-format #f "main:main1 ~A == 1244 when works\n" (Example_int 10)))

  ;; check events

  (set! gyear 2005)
  (set! gparam 155)
  (Bind "Example_nothing" "ev_nothing") 

  (Example_do_nothing 155)

  ;; Check FakeEvent

  (set! gyear 3000)
  (set! gparam 20)

  (FakeEvent "Example_nothing" "3000 20")

  (gpmi_puts_nonl "main:main2 Finished init part.\n")))

(AddTimer 1 1 "run_once" 0)

